JUCE: juce::dsp::BallisticsFilter< SampleType > Class Template Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
juce::dsp::BallisticsFilter< SampleType > Class Template Reference
juce_dsp » processors

A processor to apply standard attack / release ballistics to an input signal. More...

`#include <juce_BallisticsFilter.h>`

## Public Types
using | LevelCalculationType = BallisticsFilterLevelCalculationType

## Public Member Functions
| BallisticsFilter ()
| Constructor.
void | setAttackTime (SampleType attackTimeMs)
| Sets the attack time in ms.
void | setReleaseTime (SampleType releaseTimeMs)
| Sets the release time in ms.
void | setLevelCalculationType (LevelCalculationType newCalculationType)
| Sets how the filter levels are calculated.
void | prepare (const ProcessSpec &spec)
| Initialises the filter.
void | reset ()
| Resets the internal state variables of the filter.
void | reset (SampleType initialValue)
| Resets the internal state variables of the filter to the given initial value.
template<typename ProcessContext >
void | process (const ProcessContext &context) noexcept
| Processes the input and output samples supplied in the processing context.
SampleType | processSample (int channel, SampleType inputValue)
| Processes one sample at a time on a given channel.
void | snapToZero () noexcept
| Ensure that the state variables are rounded to zero if the state variables are denormals.

## Detailed Description

template<typename SampleType>
class juce::dsp::BallisticsFilter< SampleType >

A processor to apply standard attack / release ballistics to an input signal.

This is useful in dynamics processors, envelope followers, modulated audio effects and for smoothing animation in data visualisation.

## Member Typedef Documentation

## ◆ LevelCalculationType

template<typename SampleType >

using juce::dsp::BallisticsFilter< SampleType >::LevelCalculationType = BallisticsFilterLevelCalculationType

## Constructor & Destructor Documentation

## ◆ BallisticsFilter()

template<typename SampleType >

juce::dsp::BallisticsFilter< SampleType >::BallisticsFilter | ( |  | ) |

Constructor.

## Member Function Documentation

## ◆ setAttackTime()

template<typename SampleType >

void juce::dsp::BallisticsFilter< SampleType >::setAttackTime | ( | SampleType | attackTimeMs | ) |

Sets the attack time in ms.

Attack times less than 0.001 ms will be snapped to zero and very long attack times will eventually saturate depending on the numerical precision used.

## ◆ setReleaseTime()

template<typename SampleType >

void juce::dsp::BallisticsFilter< SampleType >::setReleaseTime | ( | SampleType | releaseTimeMs | ) |

Sets the release time in ms.

Release times less than 0.001 ms will be snapped to zero and very long release times will eventually saturate depending on the numerical precision used.

## ◆ setLevelCalculationType()

template<typename SampleType >

void juce::dsp::BallisticsFilter< SampleType >::setLevelCalculationType | ( | LevelCalculationType | newCalculationType | ) |

Sets how the filter levels are calculated.

Level calculation in digital envelope followers is usually performed using peak detection with a rectifier function (like std::abs) and filtering, which returns an envelope dependant on the peak or maximum values of the signal amplitude.

To perform an estimation of the average value of the signal you can use an RMS (root mean squared) implementation of the ballistics filter instead. This is useful in some compressor and noise-gate designs, or in specific types of volume meters.

## ◆ prepare()

template<typename SampleType >

void juce::dsp::BallisticsFilter< SampleType >::prepare | ( | const ProcessSpec & | spec | ) |

Initialises the filter.

## ◆ reset() [1/2]

template<typename SampleType >

void juce::dsp::BallisticsFilter< SampleType >::reset | ( |  | ) |

Resets the internal state variables of the filter.

## ◆ reset() [2/2]

template<typename SampleType >

void juce::dsp::BallisticsFilter< SampleType >::reset | ( | SampleType | initialValue | ) |

Resets the internal state variables of the filter to the given initial value.

## ◆ process()

template<typename SampleType >
template<typename ProcessContext >

void juce::dsp::BallisticsFilter< SampleType >::process | ( | const ProcessContext & | context | ) |
| noexcept

Processes the input and output samples supplied in the processing context.

References jassert, juce::dsp::BallisticsFilter< SampleType >::processSample(), and juce::dsp::BallisticsFilter< SampleType >::snapToZero().

## ◆ processSample()

template<typename SampleType >

SampleType juce::dsp::BallisticsFilter< SampleType >::processSample | ( | int | channel,
|  | SampleType | inputValue )

Processes one sample at a time on a given channel.

Referenced by juce::dsp::BallisticsFilter< SampleType >::process().

## ◆ snapToZero()

template<typename SampleType >

void juce::dsp::BallisticsFilter< SampleType >::snapToZero | ( |  | ) |
| noexcept

Ensure that the state variables are rounded to zero if the state variables are denormals.

This is only needed if you are doing sample by sample processing.

Referenced by juce::dsp::BallisticsFilter< SampleType >::process().

The documentation for this class was generated from the following file:

- juce_BallisticsFilter.h